﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;

namespace TestApplication
{
    public partial class MainPage : UserControl
    {
        private List<DataItem> _items = new List<DataItem>();
        public MainPage()
        {
            InitializeComponent();

            DataItem item1 = new DataItem("Item1");
            DataItem item2 = new DataItem("Item2");
            DataItem item3 = new DataItem("Item3");
            DataItem item4 = new DataItem("Item4");

            DataItem item11 = new DataItem("Item11");
            DataItem item12 = new DataItem("Item12");
            DataItem item13 = new DataItem("Item13");
            DataItem item14 = new DataItem("Item14");

            item1.DataItems.AddRange(new[] { item11, item12, item13, item14 });

            this._items.AddRange(new[] { item1, item2, item3, item4 });

            this.DataContext = this._items;
        }
    }

    public class EvenVisibilityConverter : IValueConverter
    {    
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType == typeof(Visibility))
            {
                string itemValue = ((DataItem)value).Caption;
                if ((int.Parse(itemValue[itemValue.Length - 1].ToString()) % 2) == 0)
                {
                    return Visibility.Visible;
                }
            }

            return Visibility.Collapsed;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


    public class OddVisibilityConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType == typeof(Visibility))
            {
                string itemValue = ((DataItem)value).Caption;
                if ((int.Parse(itemValue[itemValue.Length - 1].ToString()) % 2) == 0)
                {
                    return Visibility.Collapsed;
                }
            }

            return Visibility.Visible;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class DataItem
    {
        private List<DataItem> _dataItems;

        public DataItem(string caption)
        {
            this.Caption = caption;
        }

        public List<DataItem> DataItems
        {
            get
            {
                if (this._dataItems == null)
                {
                    this._dataItems = new List<DataItem>();
                }

                return this._dataItems;
            }
        }

        public string Caption
        {
            get; set;
        }
    }
}
